C     MAIN PROGRAM   with comment by izumi 1998-03-30
c----------------------------------------------------------------------
c  IELM  : Max. number of an element 
c  INODE : Max. number of a node
c  IRD   : Max. number of integration point in one element
c  IGK   : Max. size of stiffness matrix  INODE*IDIM
c  IBN   : Max. size of half band width
c  IBOUND: Max. number of constrain (force and displacement)
c  INA   : Max. number of integration point  IELM*IRD
c  INMTE : Max. number of a node in a element --> 8
c  INMNM : Max. size of element stiffness matrix  INMTE*IDIM
c  IMNUM : Max. number of the kind of material 
c  IDM   : DIMENSION
c  ICOM  : number of stress component (2-Dim->4 ,3Dim->6)
c----------------------------------------------------------------------
      INCLUDE 'para.inc'
      INCLUDE 'const.inc'
c----------------------------------------------------------------------
c  DNDX1(i): dNi/dXI, DNDETA(i) : dNi/dETA
c  X(i) : x-coordinate of node i ,Y(i) : y-coordinate ,Z(i)
c----------------------------------------------------------------------
      DIMENSION DNDXI(INMTE),DNDETA(INMTE),DNDZETA(INMTE),
     +          X(INODE),Y(INODE),Z(INODE),
c----------------------------------------------------------------------
c  B(i,j)  : elemental stiffness matrix
c  AXI(i)  : x-coordinate of i-th integration point ( -1 < AXI  < 1 )
c  AETA(i) : y-coordinate of i-th integration point ( -1 < AETA < 1 )
c  AZETA(i): z-coordinate of i-th integration point ( -1 < AZETA < 1 )
c  H(i)   : weight parameter of i-th integration point
c  D(i,j) : elastic matrix (1-x,2-y,3-z,4-xy,5-xz,6-yz)
c----------------------------------------------------------------------
     + B(ICOM,INMNM),AXI(IRD),AETA(IRD),AZETA(IRD),H(IRD),D(ICOM,ICOM),
c----------------------------------------------------------------------
c  C(i,j)  : BT(INMNM,6)*D(6,6)*B(6,INMNM) Bt*D*B
c  EK(i,j) : element stiffness matrix 
c  NN(i,j) : node number of i-th local node of element j 
c----------------------------------------------------------------------
     +     C(INMNM,INMNM),EK(INMNM,INMNM),NN(INMTE,IELM),
c----------------------------------------------------------------------
c  GK(i,j) : global stiffness matrix  i: matrix size  j:half band width
c  F(i)    : force vector of node i
c  IFOR(i) : freedom number of i-th initial load point
c  FB(i)   : load value of i-th initial load point --> Load increment vector ! modified
c----------------------------------------------------------------------
     +     GK(IGK,IBN),F(IGK),IFOR(IBOUND),FB(IBOUND),fbnow(ibound),  ! modified
c----------------------------------------------------------------------
c  IDIS(i) : freedom number of i-th constrained disp. point
c  UB(i)   : disp. value of i-th constrained disp. point
c  U(i)    : displacement value of i-th freedom --> displcement increment vector ! modified
c  EP(i,j,k) : i-th component strain at j-th element
c                k-th local integration point
c  BM(i)   : For strain (B matrix for i-th integration point)
c  SG(i,j,k) : i-th component stress at j-th element
c                k-th local integration point
c  BT(i)   : transposed B(6,INMNM) matrix 
c  BTD(i)  : BT(INMNM,6)*D(6,6)
c  fbnow(i) : present force vector  ! added
c----------------------------------------------------------------------
     +     IDIS(IBOUND),UB(IBOUND),U(IGK),EP(ICOM,IELM,IRD),
     +     BM(INA,ICOM,INMNM),SG(ICOM,IELM,IRD),BT(INMNM,ICOM),
     +     BTD(INMNM,ICOM),UNOW(igk),EPDASH(ICOM,IELM,IRD),   ! modified
c----------------------------------------------------------------------
ccc  YO(i)   : Young modulus of i-th material 
ccc  PO(i)   : Poisson ratio of i-th material
c  ECON(i,j) : i-th elastic constants of j-th material 
c  IECON(i)  : ELASTIC CHARACTER of i-th material
c  NOM(i)   : material number of i-th element
c  NKIND(i) : kind of element 1--> infinite element
c  NMTE(i) : number of a node in i-th element
c  NGNG(i) : number of integration point in i-th element
c  NEUS(i) : i : PROGRAM NODE NUMBER , NEUS(I) : USER ELEMENT NUMBER 
c  NNUS(i) : i : PROGRAM NODE NUMBER , NNUS(I) : USER NODE NUMBER 
c  UNOW(i) : present displacement vector  ! added
c  EPDASH(i,j,k) : strain increment ! added
c----------------------------------------------------------------------
     +  ECON(9,IMNUM),IECON(IMNUM),NOM(IELM),NMTE(IELM),NGNG(IELM),
     +  NEUS(IELM),NNUS(INODE),NKIND(IELM)
c----------------------------------------------------------------------
c  NSGAV(i) :  summation number of global node i
c  SGN(J,I) :  j:component i:node number(global)
c----------------------------------------------------------------------
      DIMENSION SGN(ICOM,INODE),EPN(ICOM,INODE)
      DIMENSION NSGAV(INODE)
ccc FOR CHOLESKY METHOD
      DIMENSION GKC(IBN,IGK),DR(IGK),ZM(IGK)
c----------------------------------------------------------------------
c  N    : shape function Ni
c  JINV : Inverse of Jacobian matrix
c  JM   : Jacobian matrix
c----------------------------------------------------------------------
      DOUBLE PRECISION N(INMTE),JINV(IDIM,IDIM),JM(IDIM,IDIM)
ccc FOR INFINITE ELEMENT
      DOUBLE PRECISION NIF(INMTE)
      DIMENSION DXIF(INMTE),DETIF(INMTE),DZEIF(INMTE)
c      
      OPEN(77,FILE='datacheck.dat')
      OPEN(2,FILE='result.dat')
c--------------------------------------------------------------
c FOR SUBROUTIE DATA
c  NGAUSS : Order of GAUSS integration
c  NPARA  : Analysis condition (0:plain stress,1:plain strain)
c  T      : Thickness
c  NTN    : total number of nodes
c  NTE    : total number of elements
c  NTF    : total number of freedoms
c  IE     : element number(variables)
c  NTFOR  : total number of freedoms with initial load
c  NTDIS  : total number of freedoms with initial displacement
c  NNA    : The total number of integration points
c  MNUM   : number of the kind of material
c  IECON  : elastic character 1=isotropic 2=anisotropic(orthogonal)
c--------------------------------------------------------------
      CALL DATA(A,NMTE,ECON,T
     +,NN,X,Y,Z,IFOR,FB,IDIS,UB,NGNG,NOM,IECON,NEUS,NNUS,NKIND,NSTEP) ! modified
c--- band width
c--------------------------------------------------------------
c  NB     : half band width
c--------------------------------------------------------------
      CALL BAND(NN,NMTE)
C
      CALL CHECK
C
      CALL INIT(SG,EP)

      do II = 1,ntfor
      fb(II) = fb(II)/float(NSTEP)  ! modified
      enddo
C
      incr: do III = 1, NSTEP ! added
c
      CALL CLEAR(EK,GK,F)
      NA=0
ccc For all element
      DO 150 IE=1,NTE
c--- gauss integration point
         CALL newton_cotes(AXI,AETA,AZETA,H,NMTE)
ccc For all integration point
         DO 100 K=1,NGNG(IE)
            XI   = AXI(K)
            ETA  = AETA(K)
            ZETA = AZETA(K)
            HNUM = H(K)
c******************************************************************
c--- elastic matrix 
         CALL DMAT(ECON,D,NOM,IECON)  ! Need to change this subroutine to dpmat.f
c******************************************************************
c--------------------------------------------------------------
c  NA     : through number of integration point
c--------------------------------------------------------------
            NA=NA+1
            CALL INT(XI,ETA,ZETA,N,DNDXI,DNDETA,DNDZETA,
     +               NIF,DXIF,DETIF,DZEIF,NMTE,NN,NKIND)
c--- Jacobian matrix and its inverse matrix  DETJ   : det[J]
         CALL JMAT(X,Y,Z,DNDXI,DNDETA,DNDZETA
     &            ,DXIF,DETIF,DZEIF,JM,JINV,DETJ,NN,NMTE,NKIND)
c B matrix
         CALL BMAT(JINV,B,N,DNDXI,DNDETA,DNDZETA,NMTE)
c B matrix for each integration point (NA)
         CALL BMMAT(B,NA,BM,NMTE)
c BtDB matrix
         CALL BDBMAT(B,C,D,NMTE,BT,BTD)
c element stiffness matrix 
         CALL GAUSS2(C,EK,HNUM,N,X,DETJ,NMTE,NN)
 100     CONTINUE
c
c element stiffness --> global stiffness
         CALL MERGE(EK,NN,GK,NMTE)
c clear element stiffness matrix 
         CALL CLEAR2(EK,NMTE)
 150  CONTINUE
c
c boundary condition
      CALL BOUND(IFOR,FB,F,IDIS,UB,GK)
c gauss-erase-method
c      CALL SOLVE(GK,F,U)
c cholesky method
      CALL SOLVE_C(GK,GKC,F,U,DR,ZM)
c cholesky method(displacement)
      CALL SOLVE_CD(GKC,F,U,DR,ZM)
c strain B*a
      CALL STRAIN(NN,U,EP,BM,NMTE,NGNG,EPDASH)  ! modified
c stress D*strain
      CALL STRESS(D,EPDASH,SG,NGNG)  ! modified
c update displacement vector
      call udata(U,UNOW)  ! modified
c
      end do incr
c final displcement vector is copied to u(*)
      call utotal(U,UNOW,NSTEP)
c output(averange at node)
      CALL OUTPUT_AV(U,EP,SG,NGNG,NMTE,NEUS,NNUS,NN,SGN,EPN,NSGAV)
c output
      CALL OUTPUT(X,Y,Z,U,EP,SG,NGNG,NEUS,NNUS,SGN,EPN,NSGAV)
c
      CLOSE(2)

      DO KK = 1,IRD
         write(6,*)"STR UPPER:",KK,SG(1,1,KK)
      ENDDO
      DO KK = 1,IRD
         write(6,*)"STR BOTTOM:",KK,SG(1,28,KK)
      ENDDO

      write(6,*)"DIS UPPER:",UNOW(30),UNOW(60)
      write(6,*)"DIS BOTTOM:",UNOW(270),UNOW(300)
      STOP
      END
